<?php
if (!function_exists('getallheaders'))
{
    function getallheaders()
    {
        foreach ($_SERVER as $name => $value)
        {
            if (substr($name, 0, 5) == 'HTTP_')
            {
                $headers[strtolower(str_replace(' ', '-', ucwords(strtolower(str_replace('_', ' ', substr($name, 5))))))] = $value;
            }
        }
        return $headers;
    }
}

// XML parser courtesy of wickedfather@hotmail.com
// From http://au2.php.net/manual/en/function.xml-parse-into-struct.php
class XMLThing
{
    var $rawXML;
    var $valueArray = array();
    var $keyArray = array();
    var $parsed = array();
    var $index = 0;
    var $attribKey = 'attributes';
    var $valueKey = 'value';
    var $cdataKey = 'cdata';
    var $isError = false;
    var $error = '';

    function XMLThing($xml = NULL)
    {
        $this->rawXML = $xml;
    }

    function parse($xml = NULL)
    {
        if (!is_null($xml))
        {
            $this->rawXML = $xml;
        }

        $this->isError = false;
         
        if (!$this->parse_init())
        {
            return false;
        }

        $this->index = 0;
        $this->parsed = $this->parse_recurse();
        $this->status = 'parsing complete';

        return $this->parsed;
    }

    function parse_recurse()
    {
        $found = array();
        $tagCount = array();

        while (isset($this->valueArray[$this->index]))
        {
            $tag = $this->valueArray[$this->index];
            $this->index++;

            if ($tag['type'] == 'close')
            {
                return $found;
            }

            if ($tag['type'] == 'cdata')
            {
                $tag['tag'] = $this->cdataKey;
                $tag['type'] = 'complete';
            }

            $tagName = $tag['tag'];

            if (isset($tagCount[$tagName]))
            {
                if ($tagCount[$tagName] == 1)
                {
                    $found[$tagName] = array($found[$tagName]);
                }
                 
                $tagRef =& $found[$tagName][$tagCount[$tagName]];
                $tagCount[$tagName]++;
            }
            else
            {
                $tagCount[$tagName] = 1;
                $tagRef =& $found[$tagName];
            }

            switch ($tag['type'])
            {
                case 'open':
                    $tagRef = $this->parse_recurse();

                    if (isset($tag['attributes']))
                    {
                        $tagRef[$this->attribKey] = $tag['attributes'];
                    }
                     
                    if (isset($tag['value']))
                    {
                        if (isset($tagRef[$this->cdataKey]))
                        {
                            $tagRef[$this->cdataKey] = (array)$tagRef[$this->cdataKey];
                            array_unshift($tagRef[$this->cdataKey], $tag['value']);
                        }
                        else
                        {
                            $tagRef[$this->cdataKey] = $tag['value'];
                        }
                    }
                    break;

                case 'complete':
                    if (isset($tag['attributes']))
                    {
                        $tagRef[$this->attribKey] = $tag['attributes'];
                        $tagRef =& $tagRef[$this->valueKey];
                    }

                    if (isset($tag['value']))
                    {
                        $tagRef = $tag['value'];
                    }
                    break;
            }
        }

        return $found;
    }

    function parse_init()
    {
        $this->parser = xml_parser_create();

        $parser = $this->parser;
        xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
        xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
        if (!$res = (bool)xml_parse_into_struct($parser, $this->rawXML, $this->valueArray, $this->keyArray))
        {
            $this->isError = true;
            $this->error = 'error: '.xml_error_string(xml_get_error_code($parser)).' at line '.xml_get_current_line_number($parser);
        }
        xml_parser_free($parser);

        return $res;
    }
}
/*
 * Request a secure token from the PayWay server to protect these payment details.
 *
 * $parameters is the array that maps payment parameter names to parameter values.
 *
 * The return value is the token value that should be included in the hand-off.
 */
function getToken( $parameters )
{
    // Find the port setting, if any.
    $payWayUrl = MODULE_PAYMENT_PAYWAY_BASE_URL;
    $port = 443;
    $portPos = strpos( MODULE_PAYMENT_PAYWAY_BASE_URL, ":", 6 );
    $urlEndPos = strpos( MODULE_PAYMENT_PAYWAY_BASE_URL, "/", 8 );
    if ( $portPos !== false && $portPos < $urlEndPos )
    {
        $port = (int)substr( MODULE_PAYMENT_PAYWAY_BASE_URL, ((int)$portPos) + 1, ((int)$urlEndPos));
        $payWayUrl = substr( MODULE_PAYMENT_PAYWAY_BASE_URL, 0, ((int)$portPos))
        . substr( MODULE_PAYMENT_PAYWAY_BASE_URL, ((int)$urlEndPos), strlen(MODULE_PAYMENT_PAYWAY_BASE_URL));
        //debugLog( "Found alternate port setting: " . $port );
    }

    $ch = curl_init( $payWayUrl . "RequestToken" );
    //debugLog( "Configuring token request to : " . $payWayUrl . "RequestToken" );

    if ( $port != 443 )
    {
        curl_setopt( $ch, CURLOPT_PORT, $port );
        //debugLog( "Set port to: " . $port );
    }

    curl_setopt( $ch, CURLOPT_FAILONERROR, true );
    curl_setopt( $ch, CURLOPT_FORBID_REUSE, true );
    curl_setopt( $ch, CURLOPT_FRESH_CONNECT, true );
    curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );

    // Set proxy information as required
    if ( strlen( MODULE_PAYMENT_PAYWAY_PROXY_HOST ) > 0 && strlen( MODULE_PAYMENT_PAYWAY_PROXY_PORT ) > 0 )
    {
        curl_setopt( $ch, CURLOPT_HTTPPROXYTUNNEL, true );
        curl_setopt( $ch, CURLOPT_PROXY, MODULE_PAYMENT_PAYWAY_PROXY_HOST . ":" . MODULE_PAYMENT_PAYWAY_PROXY_PORT );
        if ( strlen( MODULE_PAYMENT_PAYWAY_PROXY_USERNAME ) > 0 )
        {
            curl_setopt( $ch, CURLOPT_PROXYUSERPWD,
            MODULE_PAYMENT_PAYWAY_PROXY_USERNAME . ":" . MODULE_PAYMENT_PAYWAY_PROXY_PASSWORD );
        }
    }

    // Set timeout options
    curl_setopt( $ch, CURLOPT_CONNECTTIMEOUT, 30 );
    curl_setopt( $ch, CURLOPT_TIMEOUT, 30 );

    // Set references to certificate files
    curl_setopt( $ch, CURLOPT_CAINFO, dirname(__FILE__) . '/../local/cacerts.crt' );
    
    // Check the existence of a common name in the SSL peer's certificate
    // and also verify that it matches the hostname provided
    curl_setopt( $ch, CURLOPT_SSL_VERIFYHOST, 1 );
    
    // Verify the certificate of the SSL peer
    curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, true );
    
    // Build the parameters string to pass to PayWay
    $parametersString = '';
    $init = true;
    foreach ( $parameters as $paramName => $paramValue )
    {
        if ( $init )
        {
            $init = false;
        }
        else
        {
            $parametersString .= '&';
        }
        $parametersString .= urlencode($paramName) . '=' . urlencode($paramValue);
    }

    curl_setopt( $ch, CURLOPT_POSTFIELDS, $parametersString );

    //debugLog( "Token Request POST: " . $parametersString );

    // Make the request
    $responseText = curl_exec($ch);

    //debugLog( "Token Response: " . $responseText );

    // Check the response for errors
    $errorNumber = curl_errno( $ch );
    if ( $errorNumber != 0 )
    {
        trigger_error( "CURL Error getting token: Error Number: " . $errorNumber .
                ", Description: '" . curl_error( $ch ) . "'" );
        //debugLog( "Errors: " . curl_error( $ch ) );
        $curlError = "CURL Error getting token: Error Number: " . $errorNumber .
                ", Description: '" . curl_error( $ch ) . "'";
    }
    curl_close( $ch );
    
    if ($curlError != NULL)
    {
        return $curlError;
    }

    // Split the response into parameters
    $responseParameterArray = explode( "&", $responseText );
    $responseParameters = array();
    foreach ( $responseParameterArray as $responseParameter )
    {
        list( $paramName, $paramValue ) = explode( "=", $responseParameter, 2 );
        $responseParameters[ $paramName ] = $paramValue;
    }

    if ( array_key_exists( 'error', $responseParameters ) )
    {
        trigger_error( "Error getting token: " . $responseParameters['error'] );
        return $responseParameters['error'];
    }
    else
    {
        return $responseParameters['token'];
    }
}

?>