<?php
    include(dirname(__FILE__).'/../../config/config.inc.php');
    include(dirname(__FILE__).'/../../header.php');

    include(dirname(__FILE__).'/paywayDecrypt.php');
    
  
    $smarty->assign('cartURL', 'http://' . $_SERVER['HTTP_HOST'] . __PS_BASE_URI__ . 'order.php?step=1');
    $smarty->assign('contactURL', 'http://' . $_SERVER['HTTP_HOST'] . __PS_BASE_URI__ . 'contact-form.php');
    
    global $smarty;
    
    $payway = new payway();
  
    $encryptedText = $_GET['EncryptedParameters'];
    $sig = $_GET['Signature'];

    
    $decryptedParams = decrypt_parameters( 
        Configuration::get('PAYWAY_KEY'), 
        $encryptedText, 
        $sig );
        
    
    //If we havent got an array or its seems incomplete display a generic page
    if ( !is_array( $decryptedParams ) || !count($decryptedParams) > 1 )
    {
        $paymentMessage = 'Payment Complete';
    }
    else
    {           
        $cartId = (int)( $decryptedParams['payment_reference'] );
      
        $cart = new Cart( $cartId );
      
        //If the order exists we should display it!
        if ( $cart->OrderExists( ) )
        {
            $order = Order::getOrderByCartId( $cartId );
            Tools::redirectLink( __PS_BASE_URI__.'order-confirmation.php?id_cart='.$cartId.'&id_module='.(int)$payway->id.'&id_order='.$order->id.'&key='.$order->secure_key);
        }
        //We dont have an order yet so we create one in an "awaiting payment" status
        else
        {
            $amount = $decryptedParams['payment_amount'];
            $txResponse = $decryptedParams['response_text'];
            $paymentReference = $decryptedParams['payment_reference'];
            
            //Check we've got the nessessary fields to create the order and redirect
            if ( isset($amount) &&
                    isset($txResponse) &&
                    isset($paymentReference) )
            {        
                debugLog( 'Creating order for cart: ' . $paymentReference . ' in pending state.' );
                $payway->validateOrder( $paymentReference, _PS_OS_BANKWIRE_, $amount, 'PayWay', $txResponse );
                $order = Order::getOrderByCartId( $cartId );
                Tools::redirectLink( __PS_BASE_URI__.'order-confirmation.php?id_cart='.$cartId.'&id_module='.(int)$payway->id.'&id_order='.$order->id.'&key='.$order->secure_key);
            }    
        }  

        //If we dont know the status of the payment
        if ( !isset( $decryptedParams['summary_code'] ) )
        {
            $paymentMessage = 'Payment Complete';
        }    
        
        if ( $decryptedParams['summary_code'] == 0 )
        {
            $paymentMessage = 'Payment Approved';
        }
        else
        {
            $paymentMessage = 'Payment Declined';
        }    
    }
    
    $smarty->assign('paymentMessage', $paymentMessage);
    
    $smarty->display(dirname(__FILE__) . '/payment_return.tpl');
    
    include(dirname(__FILE__).'/../../footer.php');    
?>