<?php

  include(dirname(__FILE__).'/../../config/config.inc.php');
  include(dirname(__FILE__).'/../../header.php');

  debugLog( 'Received Server Response : ' . createParamLogString( $_POST ) );
    
  $payway = new payway();
  
  $paymentStatus = (int) $_POST['fl_success'];
  $paymentReference = (int) $_POST['payment_reference'];
  $amount = $_POST['am_payment'];
  $password = $_POST['password'];
  $txResponse = $_POST['tx_response'];
  
  if ( !isset($_POST['payment_reference']) )
  {
    debugLog( 'Could not load cart for server response as payment reference is not set' );
    throw new Exception( 'No payment reference found.' );
  }
  
  else
  {
    
      try
      {
          $orderExists = false;
          $cart = new Cart( $paymentReference );
          
          //Check if the order exists (this will mean we got a browser redirect before the
          //Server-to-Server notification arrived
          if ( $cart->OrderExists( ) )
          {           
              $orderExists = true;
              $order = Order::getOrderByCartId( $cart->id );
              $order = new Order( (int) $order );          
              $history = new OrderHistory();
              $history->id_order = intval($order->id );
          }  
                  
          //check password is correct - terminate if incorrect
          if ( $password != Configuration::get( 'PAYWAY_PASSWORD' ) )
          {
              debugLog( 'Username/Password mismatch' );
              throw new Exception( 'Username/Password mismatch' );
          }
        
          //If the payment failed
          if ( $paymentStatus != 1 )
          {
              debugLog('Response received for Failed Payment'); 

              //Create order in an error'r status              
              if ( !$orderExists )
              {
                  $payway->validateOrder( $paymentReference, Configuration::get('PS_OS_ERROR'), $amount, 'PayWay', $txResponse );
                  debugLog( 'Response Processed - Order Created' );
              }
              //Update order to reflect error'd status
              else
              {
                  $history->changeIdOrderState( intval(Configuration::get('PS_OS_ERROR')), $order );
                  $history->addWithemail( true );
                  debugLog( 'Response Received - Order status updated' );
              }    
          }
          
          else
          {
              //decrement stock and send payment confirmation email.
              debugLog('Resonse received for Approved Payment');
              
              if ( !$orderExists )
              {
                  $payway->validateOrder( $paymentReference, Configuration::get('PS_OS_PAYMENT'), $amount, 'PayWay', $txResponse );
                  debugLog( 'Response Processed - Order Created' );
              }
              else
              {
                  $history->changeIdOrderState( intval(Configuration::get('PS_OS_PAYMENT')), $order );
                  $history->addWithemail( true );
                  debugLog( 'Response Received - Order status updated' );
              }    
          }
      }
      catch ( Exception $e )
      {
          debugLog( 'Caught Exception during server notification processing: ' . $e );
          throw new Exception( 'Caught Exception during server notification processing: ' . $e );
      }
  }
?>