<?php
/**
 * PayWay Payment Notification Handler
 *
 * @version $Id: notify.php 1712 2009-03-30 07:38:09Z Aravot $
 * @package VirtueMart
 * @subpackage payment
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * VirtueMart is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
 *
 * http://virtuemart.net
 *
 * This code was based on the PayPal IPN Handler by Soeren Eberhardt.
 */
$messages = Array();
function debugLog( $msg ) {
    global $messages;
    if( PAYWAY_DEBUG == "1" ) {
        if( !defined( "_DEBUG_HEADER")  ) {
            echo "<h2>PayWay Notify.php Debug OUTPUT</h2>";
            define( "_DEBUG_HEADER", "1" );
        }
        $messages[] = "<pre>$msg</pre>";
        echo end( $messages );
    }
}

global $mosConfig_absolute_path, $mosConfig_live_site, $mosConfig_lang, $database,
$mosConfig_mailfrom, $mosConfig_fromname;

/*** access Joomla's configuration file ***/
$my_path = dirname(__FILE__);

if( file_exists($my_path."/../../../configuration.php")) {
    $absolute_path = dirname( $my_path."/../../../configuration.php" );
    require_once($my_path."/../../../configuration.php");
}
elseif( file_exists($my_path."/../../configuration.php")){
    $absolute_path = dirname( $my_path."/../../configuration.php" );
    require_once($my_path."/../../configuration.php");
}
elseif( file_exists($my_path."/configuration.php")){
    $absolute_path = dirname( $my_path."/configuration.php" );
    require_once( $my_path."/configuration.php" );
}
else {
    die( "Joomla Configuration File not found!" );
}

$absolute_path = realpath( $absolute_path );

// Set up the appropriate CMS framework
if( class_exists( 'jconfig' ) ) {
    define( '_JEXEC', 1 );
    define( 'JPATH_BASE', $absolute_path );
    define( 'DS', DIRECTORY_SEPARATOR );
     
    // Load the framework
    require_once ( JPATH_BASE . DS . 'includes' . DS . 'defines.php' );
    require_once ( JPATH_BASE . DS . 'includes' . DS . 'framework.php' );

    // create the mainframe object
    $mainframe = & JFactory::getApplication( 'site' );
     
    // Initialize the framework
    $mainframe->initialise();
     
    // load system plugin group
    JPluginHelper::importPlugin( 'system' );
     
    // trigger the onBeforeStart events
    $mainframe->triggerEvent( 'onBeforeStart' );
    $lang =& JFactory::getLanguage();
    $mosConfig_lang = $GLOBALS['mosConfig_lang']          = strtolower( $lang->getBackwardLang() );
    // Adjust the live site path
    $mosConfig_live_site = str_replace('/administrator/components/com_virtuemart', '', JURI::base());
    $mosConfig_absolute_path = JPATH_BASE;
} else {
    define('_VALID_MOS', '1');
    require_once($mosConfig_absolute_path. '/includes/joomla.php');
    require_once($mosConfig_absolute_path. '/includes/database.php');
    $database = new database( $mosConfig_host, $mosConfig_user, $mosConfig_password, $mosConfig_db, $mosConfig_dbprefix );
    $mainframe = new mosMainFrame($database, 'com_virtuemart', $mosConfig_absolute_path );
}

// load Joomla Language File
if (file_exists( $mosConfig_absolute_path. '/language/'.$mosConfig_lang.'.php' )) {
    require_once( $mosConfig_absolute_path. '/language/'.$mosConfig_lang.'.php' );
}
elseif (file_exists( $mosConfig_absolute_path. '/language/english.php' )) {
    require_once( $mosConfig_absolute_path. '/language/english.php' );
}
/*** END of Joomla config ***/


/*** VirtueMart part ***/
require_once($mosConfig_absolute_path.'/administrator/components/com_virtuemart/virtuemart.cfg.php');
include_once( ADMINPATH.'/compat.joomla1.5.php' );
require_once( ADMINPATH. 'global.php' );
require_once( CLASSPATH. 'ps_main.php' );

/* @MWM1: Logging enhancements (file logging & composite logger). */
$vmLogIdentifier = "notify.php";
require_once(CLASSPATH."Log/LogInit.php");

/* Load the PayWay Configuration File */
require_once( CLASSPATH. 'payment/ps_payway.cfg.php' );

// restart session
// Constructor initializes the session!
$sess = new ps_session();

/*** END VirtueMart part ***/

debugLog( "1. Finished Initialization of the notify.php script" );

/**
 * Read post from PayWay system and create reply
 * starting with: 'cmd=_notify-validate'...
 * then repeating all values sent: that's our VALIDATION.
 **/
$workstring = 'cmd=_notify-validate'; // Notify validate
$i = 1;
foreach ($_POST as $key => $value) {
    if (get_magic_quotes_gpc())
    // Fix issue with magic quotes
    $value = stripslashes ($value);

    if (!eregi("^[_0-9a-z-]{1,30}$",$key)  || !strcasecmp ($key, 'cmd'))  {
        // ^ Antidote to potential variable injection and poisoning
        unset ($key);
        unset ($value);
    }
}

$paramString = "";
foreach ( $_POST as $paramName => $paramValue )
{
    $params[$paramName] = $paramValue;
    if ( $paramName != "username" && $paramName != "password" )
    {
        $paramString .= "$paramName=$paramValue;";
    }
}
foreach ( $_GET as $paramName => $paramValue )
{
    $params[$paramName] = $paramValue;
    if ( $paramName != "username" && $paramName != "password" )
    {
        $paramString .= "$paramName=$paramValue;";
    }
}

debugLog( "2. Received Parameters: $paramString" );

if ( $params['username'] != PAYWAY_SECURITY_USERNAME
|| $params['password'] != PAYWAY_SECURITY_PASSWORD )
{
    // Usually this means you haven't configured your
    // security username and security password correctly in
    // virtuemart payway net module configuration.
    // If your settings are exactly right, someone's trying
    //  to send a fraudulent payment notification.
    header( "HTTP/1.1 403 Incorrect Username and Password" );
    echo "Incorrect Username and password";
}
else
{
    // Save payment
    $orderNumber = trim(stripslashes($params['payment_reference']));

    // Get the Order Details from the database
    $qv = "SELECT `order_id`, `order_number`, `user_id`, `order_subtotal`,
                      `order_total`, `order_currency`, `order_tax`, 
                      `order_shipping_tax`, `coupon_discount`, `order_discount`
                  FROM `#__{vm}_orders` 
                  WHERE `order_id`='".$orderNumber."'";
    $db = new ps_DB;
    $db->query($qv);
    $db->next_record();
    $order_id = $db->f("order_id");

    $d['order_id'] = $order_id;
    $d['notify_customer'] = "Y";

    if ( $params['cd_summary'] == '0' )
    {
        $d['order_status'] = PAYWAY_VERIFIED_STATUS;
    }
    else
    {
        $d['order_status'] = PAYWAY_INVALID_STATUS;
    }

    debugLog( '3. Input summary code=' . $params['cd_summary'] . ', Is this successful? ' . ($params['cd_summary'] == '0' ? 'y' : 'n') . ', Input order ID from payment reference=' . $orderNumber . ' -> Retrieved order ID from DB=' . $d['order_id'] . ", Order status is now '" . $d['order_status'] . "'" );

    require_once ( CLASSPATH . 'ps_order.php' );
    $ps_order= new ps_order;
    if ( $ps_order->order_status_update($d) )
    {
        // Tell PayWay that everything's fine
        echo "Success";
    }
    else
    {
        // If error results, return HTTP 500
        header( "HTTP/1.1 500 Database error while updating order status" );
        echo( "Database error while updating order status" );
    }
}
?>
