<?php
if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );
/**
*
* @package VirtueMart
* @subpackage payment
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* VirtueMart is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
*
* http://virtuemart.net
*
* This file is based on the PayWay Net module by Guy Morton (guy@virtuit.com.au),
* which was in turn based on the generic payment module by Soeren Eberhardt
* It also incorporates code from Soeren Eberhardt's PAYWAY config class.
* It has been modified to support token request payments and Payment Notification configuration.
*/

/**
* This class implements the configuration panel for PayWay Net.
* To change the default values, either do so via the virtuemart screens,
* or edit the values in ps_payway.cfg.php
* Interfacing with the payment gateway is done via the "Extra Info.txt" file.
*/

class ps_payway {

    var $classname = "ps_payway";
    var $payment_code = "PAYWAY";
    
    /**
    * Show all configuration parameters for this payment method
    * @returns boolean False when the Payment method has no configration
    */
    function show_configuration() {
        global $VM_LANG;
        $db = new ps_DB();
        
        /** Read current Configuration ***/
        include_once(CLASSPATH ."payment/".$this->classname.".cfg.php");
    ?>
    <table class="adminform">
        <tr class="row0">
            <td>
                <strong>Biller Code</strong>
            </td>
            <td>
                <input type="text" name="PAYWAY_BILLER_CODE" class="inputbox" value="<?php  echo PAYWAY_BILLER_CODE ?>" />
            </td>
            <td>Please enter your biller code here.</td>
        </tr>
        <tr class="row1">
            <td>
                <strong>Merchant ID</strong>
            </td>
            <td>
                <input type="text" name="PAYWAY_MERCHANT_ID" class="inputbox" value="<?php  echo PAYWAY_MERCHANT_ID ?>" />
            </td>
            <td>Please enter your Merchant ID here. For testing, use "TEST" as the merchant ID.</td>
        </tr>
        <tr class="row0">
            <td>
                <strong>PayPal Email</strong>
            </td>
            <td>
                <input type="text" name="PAYWAY_PAYPAL_EMAIL" class="inputbox" value="<?php  echo PAYWAY_PAYPAL_EMAIL ?>" />
            </td>
            <td>Please enter your configured PayPal email address, if applicable.</td>
        </tr>
        <tr class="row1">
            <td>
                <strong>Security Username</strong>
            </td>
            <td>
                <input type="text" name="PAYWAY_SECURITY_USERNAME" class="inputbox" value="<?php  echo PAYWAY_SECURITY_USERNAME ?>" />
            </td>
            <td>Please enter your PayWay Security Username here. This is located on the Security page of Setup Net.</td>
        </tr>
        <tr class="row0">
            <td>
                <strong>Security Password</strong>
            </td>
            <td>
                <input type="text" name="PAYWAY_SECURITY_PASSWORD" class="inputbox" value="<?php  echo PAYWAY_SECURITY_PASSWORD ?>" />
            </td>
            <td>Please enter your PayWay Security Password here. This is located on the Security page of Setup Net.</td>
        </tr>
        <tr class="row1">
            <td>
                <strong>Encryption Key</strong>
            </td>
            <td>
                <input type="text" name="PAYWAY_SECURITY_ENCRYPTION_KEY" class="inputbox" value="<?php  echo PAYWAY_SECURITY_ENCRYPTION_KEY ?>" />
            </td>
            <td>Please enter your Encryption Key here. This is located on the Security page of Setup Net.</td>
        </tr>
        <tr class="row0">
            <td>
                <strong>PayWay URL</strong>
            </td>
            <td>
                <input type="text" name="PAYWAY_URL" class="inputbox" value="<?php  echo PAYWAY_URL ?>" />
            </td>
            <td>The PayWay URL you use (https://www.payway.com.au or https://payway.stgeorge.com.au)</td>
        </tr>
        <tr class="row1">
            <td><strong>Successful Order Status</strong></td>
            <td>
                <select name="PAYWAY_VERIFIED_STATUS" class="inputbox" >
                <?php
                    $q = "SELECT order_status_name,order_status_code FROM #__{vm}_order_status ORDER BY list_order";
                    $db->query($q);
                    $order_status_code = Array();
                    $order_status_name = Array();
                    
                    while ($db->next_record()) {
                      $order_status_code[] = $db->f("order_status_code");
                      $order_status_name[] =  $db->f("order_status_name");
                    }
                    for ($i = 0; $i < sizeof($order_status_code); $i++) {
                      echo "<option value=\"" . $order_status_code[$i];
                      if (PAYWAY_VERIFIED_STATUS == $order_status_code[$i]) 
                         echo "\" selected=\"selected\">";
                      else
                         echo "\">";
                      echo $order_status_name[$i] . "</option>\n";
                    }?>
                    </select>
            </td>
            <td>Status for paid orders.</td>
        </tr>
        <tr class="row0">
            <td><strong>Pending Order Status</strong></td>
            <td>
                <select name="PAYWAY_PENDING_STATUS" class="inputbox" >
                <?php
                    for ($i = 0; $i < sizeof($order_status_code); $i++) {
                      echo "<option value=\"" . $order_status_code[$i];
                      if (PAYWAY_PENDING_STATUS == $order_status_code[$i]) 
                         echo "\" selected=\"selected\">";
                      else
                         echo "\">";
                      echo $order_status_name[$i] . "</option>\n";
                    } ?>
                    </select>
            </td>
            <td>Status for unpaid orders.</td>
        </tr>
        <tr class="row1">
            <td><strong>Invalid Order Status</strong></td>
            <td>
                <select name="PAYWAY_INVALID_STATUS" class="inputbox" >
                <?php
                    for ($i = 0; $i < sizeof($order_status_code); $i++) {
                      echo "<option value=\"" . $order_status_code[$i];
                      if (PAYWAY_INVALID_STATUS == $order_status_code[$i]) 
                         echo "\" selected=\"selected\">";
                      else
                         echo "\">";
                      echo $order_status_name[$i] . "</option>\n";
                    } ?>
                    </select>
            </td>
            <td>Status for orders with invalid payment details.</td>
        </tr>
        <tr class="row0">
            <td>
                <strong>Proxy Host</strong>
            </td>
            <td>
                <input type="text" name="PAYWAY_PROXY_HOST" class="inputbox" value="<?php  echo PAYWAY_PROXY_HOST ?>" />
            </td>
            <td>If you use a proxy, please enter its URL or network identifier here</td>
        </tr>
        <tr class="row1">
            <td>
                <strong>Proxy Port</strong>
            </td>
            <td>
                <input type="text" name="PAYWAY_PROXY_PORT" class="inputbox" value="<?php  echo PAYWAY_PROXY_PORT ?>" />
            </td>
            <td>If you use a proxy, please enter its port here</td>
        </tr>
        <tr class="row0">
            <td>
                <strong>Proxy Username</strong>
            </td>
            <td>
                <input type="text" name="PAYWAY_PROXY_USERNAME" class="inputbox" value="<?php  echo PAYWAY_PROXY_USERNAME ?>" />
            </td>
            <td>If you use a proxy and it requires credentials, please enter the username here</td>
        </tr>
        <tr class="row1">
            <td>
                <strong>Proxy Password</strong>
            </td>
            <td>
                <input type="text" name="PAYWAY_PROXY_PASSWORD" class="inputbox" value="<?php  echo PAYWAY_PROXY_PASSWORD ?>" />
            </td>
            <td>If you use a proxy and it requires credentials, please enter the password here</td>
        </tr>
    </table>

<?php
    }
    
    function has_configuration() {
      // return false if there's no configuration
      return true;
   }
   
  /**
	* Returns the "is_writeable" status of the configuration file
	* @param void
	* @returns boolean True when the configuration file is writeable, false when not
	*/
   function configfile_writeable() {
      return is_writeable( CLASSPATH."payment/".$this->classname.".cfg.php" );
   }
   
  /**
	* Returns the "is_readable" status of the configuration file
	* @param void
	* @returns boolean True when the configuration file is writeable, false when not
	*/
   function configfile_readable() {
      return is_readable( CLASSPATH."payment/".$this->classname.".cfg.php" );
   }
   
  /**
	* Writes the configuration file for this payment method
	* @param array An array of objects
	* @returns boolean True when writing was successful
	*/
   function write_configuration( &$d ) {

      $my_config_array = array(
                              "PAYWAY_BILLER_CODE" => $d['PAYWAY_BILLER_CODE'],
                              "PAYWAY_MERCHANT_ID" => $d['PAYWAY_MERCHANT_ID'],
                              "PAYWAY_PAYPAL_EMAIL" => $d['PAYWAY_PAYPAL_EMAIL'],
                              "PAYWAY_SECURITY_USERNAME" => $d['PAYWAY_SECURITY_USERNAME'],
                              "PAYWAY_SECURITY_PASSWORD" => $d['PAYWAY_SECURITY_PASSWORD'],
                              "PAYWAY_SECURITY_ENCRYPTION_KEY" => $d['PAYWAY_SECURITY_ENCRYPTION_KEY'],
                              "PAYWAY_VERIFIED_STATUS" => $d['PAYWAY_VERIFIED_STATUS'],
                              "PAYWAY_PENDING_STATUS" => $d['PAYWAY_PENDING_STATUS'],
                              "PAYWAY_INVALID_STATUS" => $d['PAYWAY_INVALID_STATUS'],
                              "PAYWAY_URL" => $d['PAYWAY_URL'],
                              "PAYWAY_PROXY_HOST" => $d['PAYWAY_PROXY_HOST'],
                              "PAYWAY_PROXY_PORT" => $d['PAYWAY_PROXY_PORT'],
                              "PAYWAY_PROXY_USERNAME" => $d['PAYWAY_PROXY_USERNAME'],
                              "PAYWAY_PROXY_PASSWORD" => $d['PAYWAY_PROXY_PASSWORD']
                            );
      $config = "<?php\n";
      $config .= "if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' ); \n\n";
      foreach( $my_config_array as $key => $value ) {
        $config .= "define ('$key', '$value');\n";
      }
      
      $config .= "?>";
  
      if ($fp = fopen(CLASSPATH ."payment/".$this->classname.".cfg.php", "w")) {
          fputs($fp, $config, strlen($config));
          fclose ($fp);
          return true;
     }
     else
        return false;
   }
   
  /**************************************************************************
  ** name: process_payment()
  ** returns: 
  ***************************************************************************/
   function process_payment($order_number, $order_total, &$d) {
        return true;
    }
   
}

?>