<?php
/*
 $Id: payway.php v1.00 2010/02/25 15:47:15 hpdl Exp $

 Copyright (c) 2010 Qvalent

 Released under the GNU General Public License
 */
require_once(dirname(__FILE__) . '/../../../includes/functions/payway_utility.php');
require_once('includes/application_top.php');

if ( !class_exists( payway ) )
{
    class payway
    {
        var $code,
            $title,
            $description,
            $enabled,
            $test_mode,
            $params,
            $order_id,
            $payment_url;

        // class constructor
        function payway()
        {
            global $order;

            $this->code = 'payway';
            $this->title = MODULE_PAYMENT_PAYWAY_TEXT_TITLE;
            $this->description = MODULE_PAYMENT_PAYWAY_TEXT_DESCRIPTION;
            $this->sort_order = MODULE_PAYMENT_PAYWAY_SORT_ORDER;
            $this->enabled =
                ((MODULE_PAYMENT_PAYWAY_STATUS == 'True') ? true : false);
            $this->test_mode =
                ((MODULE_PAYMENT_PAYWAY_TEST_MODE == 'True') ? true : false);
            if ( (int)MODULE_PAYMENT_PAYWAY_PAYMENT_PENDING_ORDER_STATUS_ID > 0 )
            {
                $this->order_status =
                    MODULE_PAYMENT_PAYWAY_PAYMENT_PENDING_ORDER_STATUS_ID;
            }
            if (is_object($order)) $this->update_status();
            $url = MODULE_PAYMENT_PAYWAY_BASE_URL;
            if ( !substr( $url, strlen( $url ) - 1 ) == "/" )
            {
                $url .= "/";
            }
            $this->payment_url = MODULE_PAYMENT_PAYWAY_BASE_URL . "MakePayment";
        }

        // class methods
        function update_status() {
            global $order;
            global $db;

            if ( $this->enabled == true && (int)MODULE_PAYMENT_PAYWAY_ZONE > 0 )
            {
                $check_flag = false;
                $check = $db->Execute( "select zone_id from "
                                         . TABLE_ZONES_TO_GEO_ZONES
                                         . " where geo_zone_id = '"
                                         . MODULE_PAYMENT_PAYWAY_ZONE
                                         . "' and zone_country_id = '"
                                         . $order->billing['country']['id']
                                         . "' order by zone_id");
                while (!$check->EOF)
                {
                    if ($check->fields['zone_id'] < 1)
                    {
                        $check_flag = true;
                        break;
                    }
                    elseif ($check->fields['zone_id'] == $order->billing['zone_id'])
                    {
                        $check_flag = true;
                        break;
                    }
                    $check->MoveNext();
                }

                if ($check_flag == false)
                {
                    $this->enabled = false;
                }
            }
        }

        function javascript_validation()
        {
            return false;
        }

        function selection()
        {
            return array('id' => $this->code,
                   'module' => $this->title);
        }

        function pre_confirmation_check()
        {
            // set the language
            global $language;
            if ( !isset( $_SESSION['language'] ) || isset( $_GET['language'] ) )
            {
                if ( !isset( $_SESSION['language'] ) )
                {
                    $_SESSION['language'] = true;
                    $_SESSION['languages_id'] = true;
                }

                include( DIR_WS_CLASSES . 'language.php' );
                $lng = new language();

                if ( isset( $_GET['language'] ) && zen_not_null( $_GET['language'] ) )
                {
                    $lng->set_language( $_GET['language'] );
                }
                else
                {
                    $lng->get_browser_language();
                }
                $language = $lng->language['directory'];
                $languages_id = $lng->language['id'];
            }
            include( DIR_WS_LANGUAGES . $language . '/' . FILENAME_CHECKOUT_PROCESS );

            // Stock Check
            $any_out_of_stock = false;
            if ( STOCK_CHECK == 'true' )
            {
                for ( $i=0, $n=sizeof( $products ); $i<$n; $i++ )
                {
                    if ( zen_check_stock( $products[$i]['id'],
                                          $products[$i]['qty'] ) )
                    {
                        $any_out_of_stock = true;
                    }
                }
                // Out of Stock
                if ( STOCK_ALLOW_CHECKOUT != 'true' && $any_out_of_stock == true )
                {
                    zen_redirect( zen_href_link( FILENAME_SHOPPING_CART ) );
                }
            }
            $this->update_status();
        }

        function confirmation()
        {
            return false;
        }
        
        function after_order_create( $orderId )
        {
            global $order_total_modules, $order, $db, $insert_id;
            $this->order_id = $orderId;
            
            // Finish creating the order. Good job, ZenCart.
            $order->create_add_products($orderId);
            
            $this->setParam( "biller_code", MODULE_PAYMENT_PAYWAY_BILLER_CODE );
            $this->setParam( "merchant_id", $this->test_mode ? "TEST" : MODULE_PAYMENT_PAYWAY_MERCHANT_ID );
            $this->setParam( "paypal_email", $this->test_mode ? "test@example.com" : MODULE_PAYMENT_PAYWAY_PAYPAL_EMAIL );
            $this->setParam( "username", MODULE_PAYMENT_PAYWAY_SECURITY_TOKEN_USERNAME );
            $this->setParam( "password", MODULE_PAYMENT_PAYWAY_SECURITY_TOKEN_PASSWORD );
            $this->setParam( "payment_reference", $this->order_id );
            $this->setParam( "payment_amount", $order->info["total"] );
            /* _Customer Group_ discounts make this not work.
            $products = $order->products;
            for ( $i=0, $n=sizeof($products); $i<$n; $i++ )
            {
                $product = $products[$i]['name'];
                $quantity = $products[$i]['qty'];
                $price = $products[$i]['final_price'];
                $this->setParam( $product, $quantity.','.$price );
            }
            $shipping = $_SESSION['shipping'];
            $this->setParam( 'Shipping Method: ' . $shipping['title'], $shipping[cost] );
            */
            $this->setParam( 'receipt_address', $order->customer['email_address'] );
            
            // Remove this parameter if you configure reply_link_post_type in PayWay Net Setup
            $this->setParam( 'reply_link_post_type', 'extended' );
            
            $token = getToken( $this->params );
            
            $_SESSION['cart']->reset( true );
            unset( $_SESSION['sendto'] );
            unset( $_SESSION['billto'] );
            unset( $_SESSION['shipping'] );
            unset( $_SESSION['payment'] );
            unset( $_SESSION['comments'] );
            unset( $_SESSION['cot_gv'] );
            $order_total_modules->clear_posts();
            
            if ( array_key_exists( 'error', $token ) )
            {
                zen_redirect(
                    $this->payment_url
                        . "?biller_code="
                        . MODULE_PAYMENT_PAYWAY_BILLER_CODE
                        . "&merchant_id=TEST&information_fields=Error getting token&Error getting token="
                        . $token['error'] );
            }
            else
            {
                zen_redirect(
                    $this->payment_url
                        . "?biller_code="
                        . MODULE_PAYMENT_PAYWAY_BILLER_CODE
                        . "&token="
                        . $token['token'] );
            }
        }


        function process_button()
        {
        }

        function before_process()
        {
            global $order;
            if( MODULE_PAYMENT_PAYWAY_PAYMENT_PENDING_ORDER_STATUS_ID > 0
                  && $order->info['order_status']
                       < MODULE_PAYMENT_PAYWAY_PAYMENT_PENDING_ORDER_STATUS_ID)
            {
                $order->info['order_status'] = MODULE_PAYMENT_PAYWAY_PAYMENT_PENDING_ORDER_STATUS_ID;
            }
        }
        
        function setParam( $key, $value )
        {
          if ( $value != NULL )
            {
                if ( strlen( $this->params ) > 0 )
                {
                    $this->params .= "&";
                }
                $this->params .= urlencode($key) . "=" . urlencode($value);
            }
        }

        function after_process()
        {
            return false;
        }

        function output_error()
        {
            return false;
        }

        function check()
        {
            global $db;
            if ( !isset( $this->_check) )
            {
                $check_query =
                    $db->Execute(
                        "select configuration_value from "
                          . TABLE_CONFIGURATION
                          . " where configuration_key = 'MODULE_PAYMENT_PAYWAY_STATUS'" );
                $this->_check = $check_query->RecordCount();
            }
            return $this->_check;
        }

        function install()
        {
            global $db;
            $payment_pending_status_id = 1;
            $processing_status_id = 2;
            
            $configInsertStart =
                "insert into "
                  . TABLE_CONFIGURATION
                  . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, ";

            $db->Execute( $configInsertStart . "set_function, date_added) values ('Enable PayWay Module', 'MODULE_PAYMENT_PAYWAY_STATUS', 'True', 'Do you want to accept payments through the PayWay gateway?', '6', '1', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
            $db->Execute( $configInsertStart . "set_function, date_added) values ('Test Mode', 'MODULE_PAYMENT_PAYWAY_TEST_MODE','False', 'Run in TEST MODE?', '6', '2', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
            $db->Execute( $configInsertStart . "date_added) values ('Biller Code', 'MODULE_PAYMENT_PAYWAY_BILLER_CODE', '', 'From the Biller Code page of PayWay Net Shopping Cart Setup', '6', '3', now())");
            $db->Execute( $configInsertStart . "date_added) values ('Merchant ID', 'MODULE_PAYMENT_PAYWAY_MERCHANT_ID', '', 'From the Merchants page under the Administration menu', '6', '4', now())");
            $db->Execute( $configInsertStart . "date_added) values ('PayPal Email', 'MODULE_PAYMENT_PAYWAY_PAYPAL_EMAIL', '', 'Your configured PayPal Email address, if applicable', '6', '5', now())");
            $db->Execute( $configInsertStart . "date_added) values ('Security Token Username', 'MODULE_PAYMENT_PAYWAY_SECURITY_TOKEN_USERNAME', '', 'Viewable on the Security page of PayWay Net Shopping Cart Setup', '6', '6', now())");
            $db->Execute( $configInsertStart . "date_added) values ('Security Token Password', 'MODULE_PAYMENT_PAYWAY_SECURITY_TOKEN_PASSWORD', '', 'Viewable on the Security page of PayWay Net Shopping Cart Setup', '6', '7', now())");
            $db->Execute( $configInsertStart . "date_added) values ('Encryption Key', 'MODULE_PAYMENT_PAYWAY_ENCRYPTION_KEY', '', 'Viewable on the last page of PayWay Net Shopping Cart Setup', '6', '8', now())");
            $db->Execute( $configInsertStart . "date_added) values ('Proxy host', 'MODULE_PAYMENT_PAYWAY_PROXY_HOST', '', 'Your proxy server''s host (leave blank if your hosting company doesn''t use a proxy server)', '6', '9', now())");
            $db->Execute( $configInsertStart . "date_added) values ('Proxy port', 'MODULE_PAYMENT_PAYWAY_PROXY_PORT', '', 'Your proxy server''s port (leave blank if your hosting company doesn''t use a proxy server)', '6', '10', now())");
            $db->Execute( $configInsertStart . "date_added) values ('Proxy username', 'MODULE_PAYMENT_PAYWAY_PROXY_USERNAME', '', 'Your proxy username (leave blank if not required)', '6', '11', now())");
            $db->Execute( $configInsertStart . "date_added) values ('Proxy password', 'MODULE_PAYMENT_PAYWAY_PROXY_PASSWORD', '', 'Your proxy password (leave blank if not required)', '6', '12', now())");
            $db->Execute( $configInsertStart . "date_added) values ('PayWay Server URL', 'MODULE_PAYMENT_PAYWAY_BASE_URL', 'https://www.payway.com.au/', 'PayWay Server Base URL', '6', '13', now())");
            $db->Execute( $configInsertStart . "set_function, use_function, date_added) values ('Set Payment Pending Order Status', 'MODULE_PAYMENT_PAYWAY_PAYMENT_PENDING_ORDER_STATUS_ID', '" . $payment_pending_status_id . "', 'Set the status of prepared but unpaid orders made with this payment module to this value', '6', '20', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
            $db->Execute( $configInsertStart . "set_function, use_function, date_added) values ('Set Paid Order Status', 'MODULE_PAYMENT_PAYWAY_PAID_ORDER_STATUS_ID', '".$processing_status_id."', 'Set the status of paid but unshipped orders made with this payment module to this value', '6', '22', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
            $db->Execute( $configInsertStart . "date_added) values ('Sort order of display.', 'MODULE_PAYMENT_PAYWAY_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
            $db->Execute( $configInsertStart . "use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_PAYWAY_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '6', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
        }

        function remove() {
            global $db;
            $db->Execute(
                "delete from "
                  . TABLE_CONFIGURATION
                  . " where configuration_key in ('"
                  . implode( "', '", $this->keys() )
                  . "')" );
        }

        function keys() {
            return array( 'MODULE_PAYMENT_PAYWAY_STATUS',
                          'MODULE_PAYMENT_PAYWAY_BILLER_CODE', 
                          'MODULE_PAYMENT_PAYWAY_MERCHANT_ID', 
                          'MODULE_PAYMENT_PAYWAY_PAYPAL_EMAIL', 
                          'MODULE_PAYMENT_PAYWAY_SECURITY_TOKEN_USERNAME', 
                          'MODULE_PAYMENT_PAYWAY_SECURITY_TOKEN_PASSWORD', 
                          'MODULE_PAYMENT_PAYWAY_ENCRYPTION_KEY',
                          'MODULE_PAYMENT_PAYWAY_TEST_MODE',
                          'MODULE_PAYMENT_PAYWAY_PROXY_HOST', 
                          'MODULE_PAYMENT_PAYWAY_PROXY_PORT', 
                          'MODULE_PAYMENT_PAYWAY_PROXY_USERNAME', 
                          'MODULE_PAYMENT_PAYWAY_PROXY_PASSWORD',
                          'MODULE_PAYMENT_PAYWAY_BASE_URL',
                          'MODULE_PAYMENT_PAYWAY_PAYMENT_PENDING_ORDER_STATUS_ID',
                          'MODULE_PAYMENT_PAYWAY_PAID_ORDER_STATUS_ID', 
                          'MODULE_PAYMENT_PAYWAY_ZONE', 
                          'MODULE_PAYMENT_PAYWAY_SORT_ORDER');
        }
    }
}
?>
