<?php
// $Id: uc_payway_net.pages.inc,v1.0.0.0 2010/10/12 14:00:00 Qvalent Exp $


/**
 * @file
 * PayWay Net ubercart module pages
 *
 */

function uc_payway_net_payment_notify() {
	/**
	 * Read post from PayWay system and create reply
	 * starting with: 'cmd=_notify-validate'...
	 * then repeating all values sent: that's our VALIDATION.
	 **/
	$workstring = 'cmd=_notify-validate'; // Notify validate
	$i = 1;
	foreach ( $_POST as $key => $value ) {
		if (get_magic_quotes_gpc ())
			// Fix issue with magic quotes
			$value = stripslashes ( $value );
		
		if (! eregi ( "^[_0-9a-z-]{1,30}$", $key ) || ! strcasecmp ( $key, 'cmd' )) {
			// ^ Antidote to potential variable injection and poisoning
			unset ( $key );
			unset ( $value );
		}
	}
	
	$paramString = "";
	foreach ( $_POST as $paramName => $paramValue ) {
		$params [$paramName] = $paramValue;
		if ($paramName != "username" && $paramName != "password") {
			$paramString .= "$paramName=$paramValue;";
		}
	}
	foreach ( $_GET as $paramName => $paramValue ) {
		$params [$paramName] = $paramValue;
		if ($paramName != "username" && $paramName != "password") {
			$paramString .= "$paramName=$paramValue;";
		}
	}
	
	if ( $params ['username'] != variable_get ( 'uc_payway_net_security_username', '' )
		   || $params ['password'] != variable_get ( 'uc_payway_net_security_password', '' ) ) {
		// Usually this means you haven't configured your
		// security username and security password correctly in
		// virtuemart payway net module configuration.
		// If your settings are exactly right, someone's trying
		//  to send a fraudulent payment notification.
		header ( "HTTP/1.1 403 Incorrect Username and Password" );
		echo "Incorrect Username and password";
	}
	else
	{
		$order_id = trim ( stripslashes ( $params ['payment_reference'] ) );
		$order = uc_order_load ( $order_id );
		if ( isset($order) ) {
			if ($params ['fl_success'] == '1') {
				$payment_amount = $params['am_payment'];
				$comment = t('Payway payment_reference: @payment_reference', array('@payment_reference' => $params['payment_reference']));
				uc_payment_enter ( $order_id, 'payway_net', $payment_amount, $order->uid, NULL, $comment );
				uc_cart_complete_sale ( $order );
				$context = array ('revision' => 'formatted-original', 'type' => 'amount' );
				$options = array ('sign' => FALSE );
				uc_order_comment_save ( $order_id, 0, t ( 'Payment of @amount submitted via PayWay Net.', array ('@amount' => uc_price ( $payment_amount, $context, $options ) ) ), 'order', 'payment_received' );
			} else {
				uc_order_comment_save ( $order_id, 0, t ( "The customer's attempted for order @payment_reference payment failed." ), array('@payment_reference' => $params['payment_reference'] ) );
			}
			// Tell PayWay that everything's fine
			return "Success";
		} else {
			// If error results, return HTTP 500
			header ( "HTTP/1.1 500 Database error while updating order status" );
			return ("Database error while updating order status");
		}
	}
}

function uc_payway_net_payment_redirect() {
	$billerCode = variable_get( 'uc_payway_net_biller_code', '' );
	$merchantId = variable_get( 'uc_payway_net_merchant_id', 'TEST' );
  $paypalEmail = variable_get( 'uc_payway_net_paypal_email', 'test@example.com' );
	$securityUsername = variable_get( 'uc_payway_net_security_username', '' );
	$securityPassword = variable_get( 'uc_payway_net_security_password', '' );
	$baseUrl = variable_get( 'uc_payway_net_payway_url', '' );
	
	$order_id = intval ( $_SESSION ['cart_order'] );
	$order = uc_order_load ( $order_id );
	$token_variables = Array (
		"username" => $securityUsername,
		"password" => $securityPassword,
		"biller_code" => $billerCode,
		"merchant_id" => $merchantId,
    "paypal_email" => $paypalEmail,
		"payment_reference" => $order_id,
		"payment_amount" => $order->order_total );
	$token = uc_payway_net_get_token( $token_variables );
	$url = $baseUrl . 'MakePayment?biller_code=' . $billerCode . '&token=' . $token;
	uc_order_update_status($order_id, 'pending');
	header ( 'Location: ' . $url, TRUE, 302 );
}